﻿// <summary>ソースコード：モデル共通定義クラス</summary>
// <author>CommonMP</author>

using System;
using System.Collections.Generic;
using System.Text;

using CommonMP.HYSSOP.Interface.HSData;
using CommonMP.HYSSOP.CoreImpl.HSData;
using CommonMP.HYSSOP.CoreImpl.HSTools;

// ToDo namespace は　モデル開発者が変更して、ユニークな名称にして下さい
namespace jp.or.jccajsce
{
    /// <summary><para>class outline:</para>
    /// <para>ＨＹＭＣＯモデル共通定義クラス</para>
    /// </summary>
    /// <remarks>
    /// <para>Remarks:</para>
    /// <para>本クラスは、必須ではないが、使用の便利さの為、常数等の定義を一つに纏めておく</para>
    /// <para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2008/10/01][新規作成]</para>
    /// </remarks>
    public class McQuasi2DSteadyFlowModelDefine
    {
        // ToDo
        // 下記にとらわれず、必要と思われる定義を設定して下さい。（自DLL内クラスで共通に使用すると思われる常数）


        //********************************
        //===== ファクトリ関連定義 ========
        //********************************
        /// <summary>モデルファクトリ識別子</summary>
        public static HySID MODEL_FACTORY = new HySID("jp.or.jccajsce.McQuasi2DSteadyFlowModel_Factory");

        //********************************
        //===== モデル関連定義 ========
        //********************************
        /// <summary>モデル種別</summary>
        public static readonly HySObjectKind MODEL_KIND = new HySObjectKind("McQuasi2DSteadyFlowModel");
        /// <summary>モデル名称</summary>
        public static readonly HySString MODEL_NAME = new HySString("準二次元不等流計算モデル（JCCA_JSCE_MODEL）");

        //**********************************
        //モデルプロパティ名称
        //**********************************
        public static readonly string PROPERTY_KEY_WORkING_DIR = "WorkingDir";
        public static readonly string PROPERTY_NAME_WORkING_DIR = "結果確認用フォルダ";
        public static readonly string PROPERTY_KEY_INPUT_FILE1 = "InputFile1";
        public static readonly string PROPERTY_NAME_INPUT_FILE1 = "標準横断ファイル";
        public static readonly string PROPERTY_KEY_INPUT_FILE2 = "InputFile2";
        public static readonly string PROPERTY_NAME_INPUT_FILE2 = "標準縦断ファイル";
        public static readonly string PROPERTY_KEY_INPUT_FILE3 = "InputFile3";
        public static readonly string PROPERTY_NAME_INPUT_FILE3 = "標準距離標ファイル";

        public static readonly string PROPERTY_KEY_OUTPUT_FILE = "OutputFile";
        public static readonly string PROPERTY_NAME_OUTPUT_FILE = "出力ファイル";
        
        public static readonly Encoding FILE_ENCODING = Encoding.GetEncoding("Shift_JIS");

        //================================
        //McFloodModel
        //================================
        /// <summary>受信パターン宣言</summary>
            
        public static readonly HySID RECEIVE_PATTERN_HOSEN_KARYUTAN_SUII_NAME = new HySID("honsenkaryutansuii");

        public static readonly HySID RECEIVE_PATTERN_HONSHISEN00_RYUHAI_NAME = new HySID("honshisen00ryuhai");
        public static readonly HySID RECEIVE_PATTERN_HONSHISEN01_RYUHAI_NAME = new HySID("honshisen01ryuhai");    
        public static readonly HySID RECEIVE_PATTERN_HONSHISEN02_RYUHAI_NAME = new HySID("honshisen02ryuhai");    
        public static readonly HySID RECEIVE_PATTERN_HONSHISEN03_RYUHAI_NAME = new HySID("honshisen03ryuhai");    
        public static readonly HySID RECEIVE_PATTERN_HONSHISEN04_RYUHAI_NAME = new HySID("honshisen04ryuhai");    
        public static readonly HySID RECEIVE_PATTERN_HONSHISEN05_RYUHAI_NAME = new HySID("honshisen05ryuhai");    
        public static readonly HySID RECEIVE_PATTERN_HONSHISEN06_RYUHAI_NAME = new HySID("honshisen06ryuhai");    
        public static readonly HySID RECEIVE_PATTERN_HONSHISEN07_RYUHAI_NAME = new HySID("honshisen07ryuhai");    
        public static readonly HySID RECEIVE_PATTERN_HONSHISEN08_RYUHAI_NAME = new HySID("honshisen08ryuhai");    
        public static readonly HySID RECEIVE_PATTERN_HONSHISEN09_RYUHAI_NAME = new HySID("honshisen09ryuhai");    
        public static readonly HySID RECEIVE_PATTERN_HONSHISEN10_RYUHAI_NAME = new HySID("honshisen10ryuhai");

        public static readonly HySID[] RECEIVE_PATTERN_HONSHISEN_RYUHAI_NAME_ARRAY = new HySID[]{
            RECEIVE_PATTERN_HONSHISEN00_RYUHAI_NAME,
            RECEIVE_PATTERN_HONSHISEN01_RYUHAI_NAME,
            RECEIVE_PATTERN_HONSHISEN02_RYUHAI_NAME,
            RECEIVE_PATTERN_HONSHISEN03_RYUHAI_NAME,
            RECEIVE_PATTERN_HONSHISEN04_RYUHAI_NAME,
            RECEIVE_PATTERN_HONSHISEN05_RYUHAI_NAME,
            RECEIVE_PATTERN_HONSHISEN06_RYUHAI_NAME,
            RECEIVE_PATTERN_HONSHISEN07_RYUHAI_NAME,
            RECEIVE_PATTERN_HONSHISEN08_RYUHAI_NAME,
            RECEIVE_PATTERN_HONSHISEN09_RYUHAI_NAME,
            RECEIVE_PATTERN_HONSHISEN10_RYUHAI_NAME
        };

        /// <summary>送信パターン宣言</summary>
        public static readonly HySID SEND_PATTERN_HONSHISEN00_SUII_NAME = new HySID("honshisen00suii");
        public static readonly HySID SEND_PATTERN_HONSHISEN01_SUII_NAME = new HySID("honshisen01suii");
        public static readonly HySID SEND_PATTERN_HONSHISEN02_SUII_NAME = new HySID("honshisen02suii");
        public static readonly HySID SEND_PATTERN_HONSHISEN03_SUII_NAME = new HySID("honshisen03suii");
        public static readonly HySID SEND_PATTERN_HONSHISEN04_SUII_NAME = new HySID("honshisen04suii");
        public static readonly HySID SEND_PATTERN_HONSHISEN05_SUII_NAME = new HySID("honshisen05suii");
        public static readonly HySID SEND_PATTERN_HONSHISEN06_SUII_NAME = new HySID("honshisen06suii");
        public static readonly HySID SEND_PATTERN_HONSHISEN07_SUII_NAME = new HySID("honshisen07suii");
        public static readonly HySID SEND_PATTERN_HONSHISEN08_SUII_NAME = new HySID("honshisen08suii");
        public static readonly HySID SEND_PATTERN_HONSHISEN09_SUII_NAME = new HySID("honshisen09suii");
        public static readonly HySID SEND_PATTERN_HONSHISEN10_SUII_NAME = new HySID("honshisen10suii");

        public static readonly HySID[] SEND_PATTERN_HONSHISEN_SUII_NAME_ARRAY = new HySID[]{
            SEND_PATTERN_HONSHISEN00_SUII_NAME,
            SEND_PATTERN_HONSHISEN01_SUII_NAME,
            SEND_PATTERN_HONSHISEN02_SUII_NAME,
            SEND_PATTERN_HONSHISEN03_SUII_NAME,
            SEND_PATTERN_HONSHISEN04_SUII_NAME,
            SEND_PATTERN_HONSHISEN05_SUII_NAME,
            SEND_PATTERN_HONSHISEN06_SUII_NAME,
            SEND_PATTERN_HONSHISEN07_SUII_NAME,
            SEND_PATTERN_HONSHISEN08_SUII_NAME,
            SEND_PATTERN_HONSHISEN09_SUII_NAME,
            SEND_PATTERN_HONSHISEN10_SUII_NAME
        };

    }
}
