﻿// <summary>ソースコード：ＨＹＭＣＯモデルファクトリクラス</summary>
// <author>CommonMP</author>

using System;
using System.Collections.Generic;
using System.Text;

using CommonMP.HYSSOP.Interface.HSData;
using CommonMP.HYSSOP.Interface.HSViewer;
using CommonMP.HYSSOP.CoreImpl.HSData;
using CommonMP.HYSSOP.CoreImpl.HSTools;

using CommonMP.HYMCO.Interface;
using CommonMP.HYMCO.Interface.Model;
using CommonMP.HYMCO.Interface.Data;
using CommonMP.HYMCO.Interface.Controller;

using CommonMP.HYSSOP.CoreImpl;
using CommonMP.HYMCO.CoreImpl.Model;
using CommonMP.HYMCO.CoreImpl.Data;

using CommonMP.HYMCO._SYSTEM_;
namespace CommonMP.HYMCO._SYSTEM_
{
    /// <summary><para>class outline:</para>
    /// <para>ＨＹＭＣＯモデルファクトリ生成</para>
    /// </summary>
    /// <remarks><para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2009/10/01][新規作成]</para>
    /// </remarks>
    public class HYMCO_MODEL_FACTORY_CREATOR_IMPLE : HYMCO_MODEL_FACTORY_CREATOR
    {
        /// <summary><para>method outline:</para>
        /// <para>コンストラクター</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> HYMCO_MODEL_FACTORY_CREATOR_IMPLE csFactCrt = new HYMCO_MODEL_FACTORY_CREATOR_IMPLE( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>生成インスタンス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public HYMCO_MODEL_FACTORY_CREATOR_IMPLE()
        {
        }
        /// <summary><para>method outline:</para>
        /// <para>演算モデルファクトリクラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McModelFactory csCalModelFactory = CreateFactory( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>演算モデルファクトリクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public CommonMP.HYMCO.Interface.Model.McModelFactory CreateFactory()
        {
            return new jp.or.jccajsce.McQuasi2DSteadyFlowModelFactory();
        }
    }
}

namespace jp.or.jccajsce
{
    /// <summary><para>class outline:</para>
    /// <para>モデルファクトリクラス</para>
    /// </summary>
    /// <remarks><para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2008/10/01][新規作成]</para>
    /// </remarks>
    public class McQuasi2DSteadyFlowModelFactory : McBasicModelFactoryBase
    {
        /// <summary><para>method outline:</para>
        /// <para>ファクトリ識別子を生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> HySID csFactID = CreateFactoryID( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>ファクトリ識別子</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override HySID CreateFactoryID()
        {
            return McQuasi2DSteadyFlowModelDefine.MODEL_FACTORY;
        }

        /// <summary><para>method outline:</para>
        /// <para>演算モデルクラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McCalModel csCalModel = CreateCalModel(csModelKind) </para>
        /// </example>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>演算モデルクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCalModel CreateCalModel(HySObjectKind csModelKind)
        {
            McBasicCalculateModelBase csCalModel = null;

            if (csModelKind.Equals(McQuasi2DSteadyFlowModelDefine.MODEL_KIND))
            {
                csCalModel = new McQuasi2DSteadyFlowModel();
            }
            return csCalModel;
        }

        /// <summary><para>method outline:</para>
        /// <para>要素内演算中データクラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McCalInfo csCalModel = CreateCalInfo( csModelKind ) </para>
        /// </example>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>要素内演算中データクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCalInfo CreateCalInfo(HySObjectKind csModelKind)
        {
            McCalInfo csCalInfoData = null;
            if (csModelKind.Equals(McQuasi2DSteadyFlowModelDefine.MODEL_KIND))
            {
                csCalInfoData = new McQuasi2DSteadyFlowModelCalInfo();
            }
            return csCalInfoData;
        }

        /// <summary><para>method outline:</para>
        /// <para>モデルプロパティ表示／設定情報クラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McPropertyInfoRoot csPropertyInf = CreateModelPropertyInfo(csLibraryID, csModelKind ) </para>
        /// </example>
        /// <param name="csLibraryID">ライブラリー識別子</param>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>モデルプロパティ表示／設定情報クラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCellModelPropertyIF CreateModelProperty(HySID csLibraryID, HySObjectKind csModelKind)
        {
            if (this.EqualFactory(csLibraryID) == false)
            {
                return null;
            }

            McCellModelPropertyInfo csRtnCellPrptyDt = null;
            if (csModelKind.Equals(McQuasi2DSteadyFlowModelDefine.MODEL_KIND) == true)
            {
                csRtnCellPrptyDt = new McCellModelPropertyInfo(csLibraryID, csModelKind);

                csRtnCellPrptyDt.AddInfoType(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_WORkING_DIR,
                    McQuasi2DSteadyFlowModelDefine.PROPERTY_NAME_WORkING_DIR, McDefine.ValKind.STRING);
                csRtnCellPrptyDt.SetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_WORkING_DIR, "");

                csRtnCellPrptyDt.AddInfoType(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE1,
                    McQuasi2DSteadyFlowModelDefine.PROPERTY_NAME_INPUT_FILE1, McDefine.ValKind.STRING);
                csRtnCellPrptyDt.SetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE1, "");

                csRtnCellPrptyDt.AddInfoType(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE2,
                    McQuasi2DSteadyFlowModelDefine.PROPERTY_NAME_INPUT_FILE2, McDefine.ValKind.STRING);
                csRtnCellPrptyDt.SetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE2, "");

                csRtnCellPrptyDt.AddInfoType(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE3,
                    McQuasi2DSteadyFlowModelDefine.PROPERTY_NAME_INPUT_FILE3, McDefine.ValKind.STRING);
                csRtnCellPrptyDt.SetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE3, "");


                csRtnCellPrptyDt.AddInfoType(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_OUTPUT_FILE,
                    McQuasi2DSteadyFlowModelDefine.PROPERTY_NAME_OUTPUT_FILE, McDefine.ValKind.STRING);
                csRtnCellPrptyDt.SetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_OUTPUT_FILE, "");


                // 受信可能なパターン
                {
                    McTranInfoPattern csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                    McQuasi2DSteadyFlowModelDefine.RECEIVE_PATTERN_HOSEN_KARYUTAN_SUII_NAME, McTranInfoDefine.SINGLE_CELL_SERIAL, "本川下流端水位") as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1); // セル内の情報は1変数
                        {
                            csCellChara.SetDataKind(0, "下流端水位", HySDataKindDefine.WATER_LEVEL, "m");
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                        csTrnPtn.SetInterpolateType(HySDefine.InterpolateType.NO_INTERPOLATE);//LINEAR); // 内挿方法設定（受信パターンのみ）
                    }
                    csRtnCellPrptyDt.AddReceivePattern(csTrnPtn);


                    for (int IR = 0; IR < 11; IR++)
                    {
                        csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                            McQuasi2DSteadyFlowModelDefine.RECEIVE_PATTERN_HONSHISEN_RYUHAI_NAME_ARRAY[IR], McTranInfoDefine.D1_CELL_SERIAL, IR.ToString("0#") + "本支川流配") as McTranInfoPattern;
                        {
                            // セル内変数設定
                            HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1); // セル内の情報は1変数
                            {
                                csCellChara.SetDataKind(0, "流配", HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/sec"); // Index0 には、流量が入る
                            }
                            csTrnPtn.SetCellDataCharacteristic(csCellChara);
                            csTrnPtn.SetInterpolateType(HySDefine.InterpolateType.NO_INTERPOLATE);//LINEAR); // 内挿方法設定（受信パターンのみ）
                        }
                        csRtnCellPrptyDt.AddReceivePattern(csTrnPtn);

                    }
                }

                // 送信可能なパターン
                {
                    for (int IR = 0; IR < 11; IR++)
                    {
                        McTranInfoPattern csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                            McQuasi2DSteadyFlowModelDefine.SEND_PATTERN_HONSHISEN_SUII_NAME_ARRAY[IR], McTranInfoDefine.D1_CELL_SERIAL, IR.ToString("0#") + "本支川水位") as McTranInfoPattern;
                        {
                            // セル内変数設定
                            HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1); // セル内の情報は1変数
                            {
                                csCellChara.SetDataKind(0, "水位", HySDataKindDefine.WATER_LEVEL, "m"); // Index0 には、水位が入る
                            }
                            csTrnPtn.SetCellDataCharacteristic(csCellChara);
                            csTrnPtn.SetInterpolateType(HySDefine.InterpolateType.NO_INTERPOLATE);//LINEAR); // 内挿方法設定（受信パターンのみ）
                        }
                        csRtnCellPrptyDt.AddSendPattern(csTrnPtn);

                    }
                }
            }
            return csRtnCellPrptyDt;
        }

        /// <summary><para>method outline:</para>
        /// <para>モデル初期化表示／設定情報生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McPropertyInfoRoot csInitialInf = CreateModelInitialInfo(csLibraryID, csModelKind ) </para>
        /// </example>
        /// <param name="csLibraryID">ライブラリー識別子</param>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>初期情報情報クラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McPropertyInfoRoot CreateModelInitialInfo(HySID csLibraryID, HySObjectKind csModelKind)
        {
            if (this.EqualFactory(csLibraryID) == false)
            {
                return null;
            }
            McInitialInfo csRtnDt = null;
            if (csModelKind.Equals(McQuasi2DSteadyFlowModelDefine.MODEL_KIND) == true)
            {
                csRtnDt = new McInitialInfo(csLibraryID, csModelKind);
            }
            return csRtnDt;
        }

        /// <summary>
        /// <para>method outline:</para>
        /// <para>モデル情報提供</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para>HySDataLinkedList csModelInfoList = GetCalModelInfoList();</para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>モデル情報のリスト</returns>
        /// <exception cref="">無し</exception>
        /// <remarks>
        /// <para>remarks:</para>
        /// <para>モデル情報(McModelInfo)をリスト形式で返却する</para>
        /// </remarks>
        public override HySDataLinkedList GetCalModelInfoList()
        {
            McModelInfo csModelInfo=null;
            csModelInfo = new McModelInfo(
                    (HySID)this.GetFactoryID(),
                    McModelLibraryDefine.DIVISION_CALCULATION_MODEL,    // <-- 演算モデルは、必ずこの値にして下さい（LibraryCategoryXML.xmlに記述されている）
                    new HySObjectKind("CAL_RIVER_MODELS"), // <-- LibraryCategoryXML.xmlに定義されている値を使用する
                    McQuasi2DSteadyFlowModelDefine.MODEL_KIND, // モデルの識別子
                    McQuasi2DSteadyFlowModelDefine.MODEL_NAME  // モデルの名称
                                          );
            csModelInfo.SetVersionInf("Ver1.0");
            csModelInfo.SetSummaryInf("準二次元不等流計算モデル（JCCA_JSCE_MODEL）");
            csModelInfo.SetCreatorInf("JCCA_JSCE");
            csModelInfo.SetIconName("jp.or.jccajsce.McQuasi2DSteadyFlowModel_Factory\\jp.or.jccajsce.McQuasi2DSteadyFlowModel");
            csModelInfo.SetManualFileName("jp.or.jccajsce.McQuasi2DSteadyFlowModel_Factory\\jp.or.jccajsce.McQuasi2DSteadyFlowModel.pdf");

            m_csCalModelInforList.AddLast(csModelInfo); // 演算モデル情報の追加
            return m_csCalModelInforList;
        }
    }
}
