﻿// <summary>ソースコード：サンプルプロパティ詳細設定画面クラス</summary>
// <author>CommonMP</author>

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using CommonMP.HYSSOP.Interface.HSData;
using CommonMP.HYSSOP.Interface.HSController;
using CommonMP.HYSSOP.Interface.HSViewer;
using CommonMP.HYSSOP.CoreImpl.HSData;
using CommonMP.HYMCO.Interface.Viewer;
using CommonMP.HYMCO.Interface.Data;
using CommonMP.HYMCO.CoreImpl.Data;
using CommonMP.HYMCO.CoreOptions.McViewer.DotNetViewer;

namespace jp.or.jccajsce
{
    /// <summary>
    /// <para>class outline:</para>
    /// <para>サンプルプロパティ詳細設定画面</para>
    /// </summary>
    /// <remarks>
    /// <para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2009/09/17][新規作成]</para>
    /// </remarks>
    public partial class McQuasi2DSteadyFlowModelPropertyDetailForm : McDotNetModelCellPropertyDetailBaseForm, McModelCellPropertyDetailFormIF
    {
        /// <summary>
        /// <para>method outline:</para>
        /// <para>デフォルトコンストラクタ</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para>McDotNetModelSamplePropertyDetailForm csSamplePropertyDetailForm = new McDotNetModelSamplePropertyDetailForm();</para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>無し</returns>
        /// <exception cref="">無し</exception>
        /// <remarks>
        /// <para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        /// 

        private string sWorkingFolder_fullpath = "";
        private string sInputFile1_fullpath = "";
        private string sInputFile2_fullpath = "";
        private string sInputFile3_fullpath = "";
        private string sOutputFile_fullpath = "";

        public McQuasi2DSteadyFlowModelPropertyDetailForm()
        {
            InitializeComponent();

        }

        /// <summary>
        /// <para>method outline:</para>
        /// <para>プロパティ表示編集</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para>EditParameter( );</para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>無し</returns>
        /// <exception cref="">無し</exception>
        /// <remarks>
        /// <para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public void EditParameter()
        {
            // 画面表示情報編集
            // ↓↓↓↓↓サンプルロジック↓↓↓↓↓
            McModelPropertyInfo csModelPropertyInfo = m_csPropertyInfo as McModelPropertyInfo;
            if (csModelPropertyInfo != null)
            {
                textBox1.Text = csModelPropertyInfo.GetStepTime().ToString();

                string tmp = null;
                csModelPropertyInfo.GetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_WORkING_DIR, ref tmp);
                m_tbWorkingFolder.Text = tmp;

                csModelPropertyInfo.GetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE1, ref tmp);
                m_tbInputFile1.Text = tmp;

                csModelPropertyInfo.GetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE2, ref tmp);
                m_tbInputFile2.Text = tmp;

                csModelPropertyInfo.GetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE3, ref tmp);
                m_tbInputFile3.Text = tmp;

                csModelPropertyInfo.GetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_OUTPUT_FILE, ref tmp);
                m_tbOutputFile.Text = tmp;
            }
        }

        /// <summary>
        /// <para>method outline:</para>
        /// <para>作業フォルダ設定ボタンクリック処理</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para>button1_Click(sender,e);</para>
        /// </example>
        /// <param name="sender">object</param>
        /// <param name="e">Event</param>
        /// <returns>無し</returns>
        /// <exception cref="">無し</exception>
        /// <remarks>
        /// <para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        private void m_btWorkingFolder_Click(object sender, EventArgs e)
        {
            McModelPropertyInfo csModelPropertyInfo = m_csPropertyInfo as McModelPropertyInfo;
            McQuasi2DSteadyFlowModelPropertyScreen csPrptyScreen = this.m_csScreen as McQuasi2DSteadyFlowModelPropertyScreen;
            FolderBrowserDialog fbd = new FolderBrowserDialog();

            if (m_tbWorkingFolder.Text.Trim().Length > 0 && System.IO.Directory.Exists(m_tbWorkingFolder.Text.Trim()))
            {
                fbd.SelectedPath = m_tbWorkingFolder.Text.Trim();
            }
            else
            {
                fbd.SelectedPath = csPrptyScreen.GetProjectGroupDirectory().ToString();
            }
            
            if (fbd.ShowDialog() == DialogResult.OK)
            {
                HySString csRelativePath = new HySString("");
                HySString csAbsolutePath = new HySString(fbd.SelectedPath);
                csPrptyScreen.GetRelativePathBasedOnProjectGroup(csAbsolutePath, ref csRelativePath);
                m_tbWorkingFolder.Text = csRelativePath.ToString();
                csModelPropertyInfo.SetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_WORkING_DIR, m_tbWorkingFolder.Text);
                sWorkingFolder_fullpath = fbd.SelectedPath;
            }
        }

        private void m_btInputFile1_Click(object sender, EventArgs e)
        {
            McModelPropertyInfo csModelPropertyInfo = m_csPropertyInfo as McModelPropertyInfo;
            McQuasi2DSteadyFlowModelPropertyScreen csPrptyScreen = this.m_csScreen as McQuasi2DSteadyFlowModelPropertyScreen;
            OpenFileDialog ofd = new OpenFileDialog();
            if (m_tbInputFile1.Text.Trim().Length > 0 && System.IO.File.Exists(m_tbInputFile1.Text.Trim()))
            {
                ofd.FileName = m_tbInputFile1.Text.Trim();
            }
            else if (m_tbInputFile1.Text.Trim().Length > 0 && System.IO.Directory.Exists(System.IO.Path.GetDirectoryName(m_tbInputFile1.Text.Trim())))
            {
                ofd.InitialDirectory = System.IO.Path.GetDirectoryName(m_tbInputFile1.Text.Trim());
            }
            else
            {
                ofd.InitialDirectory = csPrptyScreen.GetProjectGroupDirectory().ToString() + "\\InputData";
            }
                

            if (ofd.ShowDialog() == DialogResult.OK)
            {
                HySString csRelativePath = new HySString("");
                HySString csAbsolutePath = new HySString(ofd.FileName);
                csPrptyScreen.GetRelativePathBasedOnProjectGroup(csAbsolutePath, ref csRelativePath);
                m_tbInputFile1.Text = csRelativePath.ToString();
                csModelPropertyInfo.SetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE1, m_tbInputFile1.Text);
                sInputFile1_fullpath = ofd.FileName;
            }
        }

        private void m_btInputFile2_Click(object sender, EventArgs e)
        {
            McModelPropertyInfo csModelPropertyInfo = m_csPropertyInfo as McModelPropertyInfo;
            McQuasi2DSteadyFlowModelPropertyScreen csPrptyScreen = this.m_csScreen as McQuasi2DSteadyFlowModelPropertyScreen;
            OpenFileDialog ofd = new OpenFileDialog();
            if (m_tbInputFile2.Text.Trim().Length > 0 && System.IO.File.Exists(m_tbInputFile2.Text.Trim()))
            {
                ofd.FileName = m_tbInputFile2.Text.Trim();
            }
            else if (m_tbInputFile2.Text.Trim().Length > 0 && System.IO.Directory.Exists(System.IO.Path.GetDirectoryName(m_tbInputFile2.Text.Trim())))
            {
                ofd.InitialDirectory = System.IO.Path.GetDirectoryName(m_tbInputFile2.Text.Trim());
            }
            else
            {
                ofd.InitialDirectory = csPrptyScreen.GetProjectGroupDirectory().ToString() + "\\InputData";
            }

            if (ofd.ShowDialog() == DialogResult.OK)
            {
                HySString csRelativePath = new HySString("");
                HySString csAbsolutePath = new HySString(ofd.FileName);
                csPrptyScreen.GetRelativePathBasedOnProjectGroup(csAbsolutePath, ref csRelativePath);
                m_tbInputFile2.Text = csRelativePath.ToString();
                csModelPropertyInfo.SetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE2, m_tbInputFile2.Text);
                sInputFile2_fullpath = ofd.FileName;
            }
        }

        private void m_btInputFile3_Click(object sender, EventArgs e)
        {
            McModelPropertyInfo csModelPropertyInfo = m_csPropertyInfo as McModelPropertyInfo;
            McQuasi2DSteadyFlowModelPropertyScreen csPrptyScreen = this.m_csScreen as McQuasi2DSteadyFlowModelPropertyScreen;
            OpenFileDialog ofd = new OpenFileDialog();
            if (m_tbInputFile3.Text.Trim().Length > 0 && System.IO.File.Exists(m_tbInputFile3.Text.Trim()))
            {
                ofd.FileName = m_tbInputFile3.Text.Trim();
            }
            else if (m_tbInputFile3.Text.Trim().Length > 0 && System.IO.Directory.Exists(System.IO.Path.GetDirectoryName(m_tbInputFile3.Text.Trim())))
            {
                ofd.InitialDirectory = System.IO.Path.GetDirectoryName(m_tbInputFile3.Text.Trim());
            }
            else
            {
                ofd.InitialDirectory = csPrptyScreen.GetProjectGroupDirectory().ToString() + "\\InputData";
            }

            if (ofd.ShowDialog() == DialogResult.OK)
            {
                HySString csRelativePath = new HySString("");
                HySString csAbsolutePath = new HySString(ofd.FileName);
                csPrptyScreen.GetRelativePathBasedOnProjectGroup(csAbsolutePath, ref csRelativePath);
                m_tbInputFile3.Text = csRelativePath.ToString();
                csModelPropertyInfo.SetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE3, m_tbInputFile3.Text);
                sInputFile3_fullpath = ofd.FileName;
            }
        }

//        private void m_btInputFile4_Click(object sender, EventArgs e)
//        {
//            McModelPropertyInfo csModelPropertyInfo = m_csPropertyInfo as McModelPropertyInfo;
//            McQuasi2DSteadyFlowModelPropertyScreen csPrptyScreen = this.m_csScreen as McQuasi2DSteadyFlowModelPropertyScreen;
//            OpenFileDialog ofd = new OpenFileDialog();
//            if (m_tbInputFile4.Text.Trim().Length > 0 && System.IO.File.Exists(m_tbInputFile4.Text.Trim()))
//            {
//                ofd.FileName = m_tbInputFile4.Text.Trim();
//            }
//            else if (m_tbInputFile4.Text.Trim().Length > 0 && System.IO.Directory.Exists(System.IO.Path.GetDirectoryName(m_tbInputFile4.Text.Trim())))
//            {
//                ofd.InitialDirectory = System.IO.Path.GetDirectoryName(m_tbInputFile4.Text.Trim());
//            }
//            else
//            {
//                ofd.InitialDirectory = csPrptyScreen.GetProjectGroupDirectory().ToString() + "\\InputData";
//            }
//
//        }

        private void m_btOutputFile_Click(object sender, EventArgs e)
        {
            McModelPropertyInfo csModelPropertyInfo = m_csPropertyInfo as McModelPropertyInfo;
            McQuasi2DSteadyFlowModelPropertyScreen csPrptyScreen = this.m_csScreen as McQuasi2DSteadyFlowModelPropertyScreen;
            SaveFileDialog sfd = new SaveFileDialog();
            if (m_tbOutputFile.Text.Trim().Length > 0 && System.IO.File.Exists(m_tbOutputFile.Text.Trim()))
            {
                sfd.FileName = m_tbOutputFile.Text.Trim();
            }
            else if (m_tbOutputFile.Text.Trim().Length > 0 && System.IO.Directory.Exists(System.IO.Path.GetDirectoryName(m_tbOutputFile.Text.Trim())))
            {
                sfd.InitialDirectory = System.IO.Path.GetDirectoryName(m_tbOutputFile.Text.Trim());
            }
            else
            {
                sfd.InitialDirectory = csPrptyScreen.GetProjectGroupDirectory().ToString() + "\\OutputData";
            }

            //上書き確認なし
            sfd.OverwritePrompt = false;

            if (sfd.ShowDialog() == DialogResult.OK)
            {
                HySString csRelativePath = new HySString("");
                HySString csAbsolutePath = new HySString(sfd.FileName);
                csPrptyScreen.GetRelativePathBasedOnProjectGroup(csAbsolutePath, ref csRelativePath);
                m_tbOutputFile.Text = csRelativePath.ToString();
                csModelPropertyInfo.SetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_OUTPUT_FILE, m_tbOutputFile.Text);
                sOutputFile_fullpath = sfd.FileName;
            }
        }

        /// <summary>
        /// <para>method outline:</para>
        /// <para>設定ボタンクリック処理</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para>button5_Click(sender,e);</para>
        /// </example>
        /// <param name="sender">object</param>
        /// <param name="e">Event</param>
        /// <returns>無し</returns>
        /// <exception cref="">無し</exception>
        /// <remarks>
        /// <para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        private void DecideButton_Click(object sender, EventArgs e)
        {
            // 設定ボタン押下時の処理を記述する。
            // ①入力データの整合性チェックする。
            // 　入力データに異常があれば異常項目を通知し、メソッド終了（return）
            // ②既存の情報と変更があるかチェックする。
            // ③②で変更があった場合
            // 　入力データの保存をする。
            // 　m_csPropertyInfoおよびm_csInitialInfoへ入力データを保存
            // 　DialogResultへDialogResult.OKをセット
            // ③②で変更が無かった場合
            // 　DialogResultへDialogResult.Cancelをセット
            // ④画面終了（Close）
            //if (m_tbWorkingFolder.Text.Trim().Length < 1)
            //{
            //    MessageBox.Show("作業フォルダが指定されていません。", Text, MessageBoxButtons.OK, MessageBoxIcon.Warning);
            //    m_tbWorkingFolder.Focus();
            //    return;
            //}

            SetFullPath();
            
            if (!System.IO.Directory.Exists(sWorkingFolder_fullpath))
            {
                MessageBox.Show("作業フォルダとして指定されているフォルダは存在しません。", Text, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                m_tbWorkingFolder.Focus();
                m_tbWorkingFolder.SelectAll();
                return;
            }

            if (m_tbInputFile1.Text.Trim().Length < 1)
            {
                MessageBox.Show("標準入力ファイルの横断ファイルが指定されていません。", Text, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                m_tbInputFile1.Focus();
                return;
            }
            if (!System.IO.File.Exists(sInputFile1_fullpath))
            {
                MessageBox.Show("標準入力ファイルの横断ファイルとして指定されているファイルは存在しません。", Text, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                m_tbInputFile1.Focus();
                m_tbInputFile1.SelectAll();
                return;
            }

            if (m_tbInputFile2.Text.Trim().Length < 1)
            {
                MessageBox.Show("標準入力ファイルの縦断ファイルが指定されていません。", Text, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                m_tbInputFile2.Focus();
                return;
            }
            if (!System.IO.File.Exists(sInputFile2_fullpath))
            {
                MessageBox.Show("標準入力ファイルの縦断ファイルとして指定されているファイルは存在しません。", Text, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                m_tbInputFile2.Focus();
                m_tbInputFile2.SelectAll();
                return;
            }

            if (m_tbInputFile3.Text.Trim().Length < 1)
            {
                MessageBox.Show("標準入力ファイルの距離標ファイルが指定されていません。", Text, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                m_tbInputFile3.Focus();
                return;
            }
            if (!System.IO.File.Exists(sInputFile3_fullpath))
            {
                MessageBox.Show("標準入力ファイルの距離標ファイルとして指定されているファイルは存在しません。", Text, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                m_tbInputFile3.Focus();
                m_tbInputFile3.SelectAll();
                return;
            }

            //if (m_tbInputFile4.Text.Trim().Length < 1)
            //{
            //    MessageBox.Show("計算条件ファイルが指定されていません。", Text, MessageBoxButtons.OK, MessageBoxIcon.Warning);
            //    m_tbInputFile4.Focus();
            //    return;
            //}
            //if (!System.IO.File.Exists(sInputFile4_fullpath)
            //{
            //    MessageBox.Show("計算条件ファイルとして指定されているファイルは存在しません。", Text, MessageBoxButtons.OK, MessageBoxIcon.Warning);
            //    m_tbInputFile4.Focus();
            //    m_tbInputFile4.SelectAll();
            //    return;
            //}

            if (m_tbOutputFile.Text.Trim().Length < 1)
            {
                MessageBox.Show("出力ファイルが指定されていません。", Text, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                m_tbOutputFile.Focus();
                return;
            }
            if (!System.IO.Directory.Exists(System.IO.Path.GetDirectoryName(sOutputFile_fullpath)))
            {
                MessageBox.Show("出力ファイルを出力するフォルダは存在しません。", Text, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                m_tbOutputFile.Focus();
                m_tbOutputFile.SelectAll();
                return;
            }
            if (IsExistsPattern(sOutputFile_fullpath))
            {
                string sFNm = System.IO.Path.GetFileNameWithoutExtension(sOutputFile_fullpath);
                string sExt = System.IO.Path.GetExtension(sOutputFile_fullpath);
                string sMsg = string.Format("指定された出力ファイル[{0}_1{1}]～[{0}_999{1}]は存在します。上書きされますがよろしいですか？", sFNm, sExt);
                if (MessageBox.Show(sMsg, "上書き確認", MessageBoxButtons.OKCancel, MessageBoxIcon.Information) != DialogResult.OK)
                {
                    m_tbOutputFile.Focus();
                    m_tbOutputFile.SelectAll();
                    return;
                }
            }

            if (textBox1.Text.Trim().Length < 1)
            {
                MessageBox.Show("計算間隔が指定されていません。", Text, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                textBox1.Focus();
                return;
            }
            double tempd;
            if (!double.TryParse(textBox1.Text.Trim(), out tempd))
            {
                MessageBox.Show("計算間隔に数値が指定されていません。", Text, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                textBox1.Focus();
                return;
            }


            McModelPropertyInfo csModelPropertyInfo = m_csPropertyInfo as McModelPropertyInfo;
            McModelInitialInfo csModelInitialInfo = m_csInitialInfo as McModelInitialInfo;

            bool changed = false;
            string tmp = null;
            if(csModelPropertyInfo.GetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_WORkING_DIR, ref tmp)){
                if (m_tbWorkingFolder.Text.Trim() != tmp)
                {
                    csModelPropertyInfo.SetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_WORkING_DIR, m_tbWorkingFolder.Text.Trim());
                    changed = true;
                }
            }
            if (csModelPropertyInfo.GetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE1, ref tmp))
            {
                if (m_tbInputFile1.Text.Trim() != tmp)
                {
                    csModelPropertyInfo.SetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE1, m_tbInputFile1.Text.Trim());
                    changed = true;
                }
            }
            if (csModelPropertyInfo.GetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE2, ref tmp))
            {
                if (m_tbInputFile2.Text.Trim() != tmp)
                {
                    csModelPropertyInfo.SetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE2, m_tbInputFile2.Text.Trim());
                    changed = true;
                }
            }
            if (csModelPropertyInfo.GetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE3, ref tmp))
            {
                if (m_tbInputFile3.Text.Trim() != tmp)
                {
                    csModelPropertyInfo.SetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE3, m_tbInputFile3.Text.Trim());
                    changed = true;
                }
            }
            //if (csModelPropertyInfo.GetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE4, ref tmp))
            //{
            //    if (m_tbInputFile4.Text.Trim() != tmp)
            //    {
            //        csModelPropertyInfo.SetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE4, m_tbInputFile4.Text.Trim());
            //        changed = true;
            //    }
            //}
            if (csModelPropertyInfo.GetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_OUTPUT_FILE, ref tmp))
            {
                if (m_tbOutputFile.Text.Trim() != tmp)
                {
                    csModelPropertyInfo.SetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_OUTPUT_FILE, m_tbOutputFile.Text.Trim());
                    changed = true;
                }
            }
            if (tempd != csModelPropertyInfo.GetStepTime())
            {
                csModelPropertyInfo.SetStepTime(tempd);
                changed = true;
            }


            DialogResult = changed ? DialogResult.OK : DialogResult.Cancel;
            Close();
        }

        /// <summary>
        /// <para>method outline:</para>
        /// <para>キャンセルボタンクリック処理</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para>button5_Click(sender,e);</para>
        /// </example>
        /// <param name="sender">object</param>
        /// <param name="e">Event</param>
        /// <returns>無し</returns>
        /// <exception cref="">無し</exception>
        /// <remarks>
        /// <para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        private void AbortButton_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
            Close();
        }
        
        /// <summary>
        /// <para>method outline:</para>
        /// <para>ファイル入力ボタンクリック処理</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para>button4_Click(sender,e);</para>
        /// </example>
        /// <param name="sender">object</param>
        /// <param name="e">Event</param>
        /// <returns>無し</returns>
        /// <exception cref="">無し</exception>
        /// <remarks>
        /// <para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
//        private void button4_Click(object sender, EventArgs e)
//        {
            // ファイル入力ボタン押下時の処理を記述する。
//        }

        /// <summary>
        /// <para>method outline:</para>
        /// <para>ファイル出力ボタンクリック処理</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para>button5_Click(sender,e);</para>
        /// </example>
        /// <param name="sender">object</param>
        /// <param name="e">Event</param>
        /// <returns>無し</returns>
        /// <exception cref="">無し</exception>
        /// <remarks>
        /// <para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
//        private void button5_Click(object sender, EventArgs e)
//        {
            // ファイル出力ボタン押下時の処理を記述する。

//        }

        /// <summary><para>method outline:</para>
        /// <para>ファイル存在チェック（_999を付けたファイルのチェック）</para>
        /// </summary>
        /// <param name="sFileNamePath">ファイル名パス</param>
        /// <returns>True=存在する/False=存在しない</returns>
        private bool IsExistsPattern(string sFileNamePath)
        {
            string sRootPath = System.IO.Path.GetDirectoryName(sFileNamePath);
            string sFNm = System.IO.Path.GetFileNameWithoutExtension(sFileNamePath);
            string sExt = System.IO.Path.GetExtension(sFileNamePath);
            string sSearchPtn = sFNm + "_[0-9]+" + sExt;

            string[] sFiles = System.IO.Directory.GetFiles(sRootPath, string.Format("{0}_*{1}", sFNm, sExt));
            foreach (string sPath in sFiles)
            {
                string sNm = System.IO.Path.GetFileName(sPath);
                if (System.Text.RegularExpressions.Regex.IsMatch(sNm, sSearchPtn))
                {
                    return true;
                }
            }
            return false;
        }


        private void SetFullPath()
        {

            McModelPropertyInfo csModelPropertyInfo = m_csPropertyInfo as McModelPropertyInfo;
            McQuasi2DSteadyFlowModelPropertyScreen csPrptyScreen = this.m_csScreen as McQuasi2DSteadyFlowModelPropertyScreen;
            if (csModelPropertyInfo != null)
            {
                textBox1.Text = csModelPropertyInfo.GetStepTime().ToString();

                string tmp = null;
                csModelPropertyInfo.GetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_WORkING_DIR, ref tmp);
                if (tmp.IndexOf(":") >= 0 || tmp.IndexOf("..") >= 0)
                {
                    sWorkingFolder_fullpath = tmp;
                }
                else
                {
                    sWorkingFolder_fullpath = csPrptyScreen.GetProjectGroupDirectory().ToString() + "\\" + tmp;
                }

                csModelPropertyInfo.GetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE1, ref tmp);
                if (tmp.IndexOf(":") >= 0 || tmp.IndexOf("..") >= 0)
                {
                    sInputFile1_fullpath = tmp;
                }
                else
                {
                    sInputFile1_fullpath = csPrptyScreen.GetProjectGroupDirectory().ToString() + "\\" + tmp;
                }

                csModelPropertyInfo.GetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE2, ref tmp);
                m_tbInputFile2.Text = tmp;
                if (tmp.IndexOf(":") >= 0 || tmp.IndexOf("..") >= 0)
                {
                    sInputFile2_fullpath = tmp;
                }
                else
                {
                    sInputFile2_fullpath = csPrptyScreen.GetProjectGroupDirectory().ToString() + "\\" + tmp;
                }

                csModelPropertyInfo.GetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE3, ref tmp);
                if (tmp.IndexOf(":") >= 0 || tmp.IndexOf("..") >= 0)
                {
                    sInputFile3_fullpath = tmp;
                }
                else
                {
                    sInputFile3_fullpath = csPrptyScreen.GetProjectGroupDirectory().ToString() + "\\" + tmp;
                }

                //csModelPropertyInfo.GetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_INPUT_FILE4, ref tmp);
                //m_tbInputFile4.Text = tmp;

                csModelPropertyInfo.GetInfo(McQuasi2DSteadyFlowModelDefine.PROPERTY_KEY_OUTPUT_FILE, ref tmp);
                if (tmp.IndexOf(":") >= 0 || tmp.IndexOf("..") >= 0)
                {
                    sOutputFile_fullpath = tmp;
                }
                else
                {
                    sOutputFile_fullpath = csPrptyScreen.GetProjectGroupDirectory().ToString() + "\\" + tmp;
                }

            }
        }
                              
    }
}